uniform sampler2D id_tex;
uniform sampler2D ao_tex;
uniform float nr_lights;
varying vec3 atom_posIn;
varying float atom_radiusIn;

varying vec2 ao_pos;

void main()
{
	float u = gl_TexCoord[0].s;
	float v = gl_TexCoord[0].t;
	float h = 1.0 - abs(u) - abs(v);
	vec3 spherePos;
	vec4 lightPos;
	vec4 curr_col;

	float sn;

	if(h >= 0.0) {
		spherePos = vec3(u, v, -h);
	} else {
		spherePos = vec3(sign(u)*(1.0-abs(v)), sign(v)*(1.0 - abs(u)), -h);
	}
	spherePos = normalize(spherePos) * atom_radiusIn + atom_posIn;
	lightPos = gl_TextureMatrix[7] * vec4(spherePos, 1.0);
	lightPos = lightPos / lightPos.w;

	curr_col = texture2D(ao_tex, ao_pos * 0.5 + vec2(0.5));

	if( texture2D(id_tex,lightPos.st).z < lightPos.z) {
	  // shadow
	  gl_FragColor = curr_col;
	} else {
	  gl_FragColor = curr_col + vec4(vec3(2.0 / nr_lights), 1.0);
	}

	// Use this to verify the id_buffer:
	//gl_FragColor = texture2D(id_tex, gl_TexCoord[0].st * 0.5 + vec2(0.5));

	gl_FragColor.a = 1.0;
}

#if 0
uniform int first_run;

uniform sampler2D id_tex;
uniform sampler2D ao_tex;
varying vec2 ao_pos;

void main(void)
{
	float diff;
	vec4 id_vec;
	vec4 addition;
	vec4 current;
	
	id_vec = texture2D(id_tex, gl_TexCoord[0].st);
	diff = length(gl_Color - id_vec);
	addition = vec4(vec3(diff < 0.1? 1.0/14.0 : 0.0), 1.0);
	current = ((first_run == 1) ? vec4(0.0) : texture2D(ao_tex, ao_pos));
  gl_FragColor = addition + current;
}
#endif