uniform float protein_radius;

attribute vec3 start;
varying vec3 startIn;
attribute vec3 dir;
varying vec3 dirIn;
attribute float radius;
varying float radiusIn;

varying vec2 ao_pos;
varying vec3 center;

varying vec3 normal_1;
varying vec3 normal_2;

void main() {
	vec4 pos;
	
	pos = gl_Vertex;
  gl_Position = gl_ModelViewProjectionMatrix * pos;
	gl_TexCoord[0] = gl_MultiTexCoord0;
	ao_pos = (gl_ModelViewProjectionMatrix * pos).st;
	gl_FrontColor = gl_Color;
	//ao_pos = atom_pos.xy * atom_radius;
	startIn = start;
	radiusIn = 0.5 * radius / protein_radius;
	dirIn = 0.5 * dir;

	// Make a fixed local coordinate system on a cylinder
	normal_1 = vec3(dir.y, -1.0*dir.x,0);
	if(abs(dir.x) < 0.000000001 && abs(dir.y) < 0.000000001) {
	  normal_1 = vec3(1.0, 0.0, 0.0); 
	} else {
	  normal_1 = vec3(dir.y, -1.0*dir.x,0);
	}
	normal_1 = normalize(normal_1);
	normal_2 = normalize(cross(normal_1, dir));

	center = start + 0.5*dir;
}
